var hosts = [];

hosts[IMAGESHACK] =
{
	name: "ImageShack",
	types: ["jpeg", "JPEG", "jpg", "JPG", "png", "PNG", "gif", "GIF", "bmp", "BMP", "tif", "TIF", "tiff", "TIFF", "swf", "SWF"],
	min_size: 1,
	max_size: 1572864,
	login_required: false,
	prefs: ["auto_login", "remove_thumb_bar", "do_resize", "resize_dimensions"],
	username: null,
	init:
	function()
	{
		if (this.auto_login)
		{
			this.doLogin(true, null);
		}
	},
	isLoggedIn:
	function()
	{
		return this.username ? true : false;
	},
	getUploadUrl:
	function()
	{
		return "http://imageshack.us/index.php";
	},
	getUserName:
	function()
	{
		return this.username;
	},
	getStreamData:
	function(file_name)
	{
		return "\r\n-----------------------------" + multipart_boundary + (this.remove_thumb_bar ? "\r\nContent-Disposition: form-data; name=\"rembar\"\r\n\r\n1\r\n-----------------------------" + multipart_boundary : "") + (this.do_resize ? "\r\nContent-Disposition: form-data; name=\"optimage\"\r\n\r\n1\r\n-----------------------------" + multipart_boundary + "\r\nContent-Disposition: form-data; name=\"optsize\"\r\n\r\n" + this.resize_dimensions + "\r\n-----------------------------" + multipart_boundary : "") + "\r\nContent-Disposition: form-data; name=\"fileupload\"; filename=\"" + file_name + "\"\r\nContent-Type: image\r\n\r\n";
	},
	processUpload:
	function(responseText, image)
	{
		var image_info = responseText.match(/_trackEvent\("done-click","ibl_fs_direct"\);'.*?value="([^"]*)"\/>/);
		if (image_info)
		{
			image[STATUS] = DONE;
			var image_url = image_info[1];
			image[URL] = image_url;
			if (responseText.indexOf("Thumbnail for Websites") != -1)
			{
				image[THUMB] = image_url.replace(/^([^]*)(\.[^]*?)$/, "$1.th$2");
				}else{
					image[THUMB] = image_url;
				}
				}else{
					var error = responseText.match(/<font color="red">([^<]*?)<\/font>/);
					if (error)
					{
						if (/^Your file type "[^]*?" is not allowed\.$/.test(error[1]))
						{
							image[STATUS] = ERROR_TYPE;
							}else if (/^The file you attempted to upload is [^]*? kb\. Please resize the file so that it is less than 1024 kb\.$/.test(error[1]) || /Please click "Browse" and select a file to upload\.$/.test(error[1])){
								image[STATUS] = ERROR_SIZE;
								}else if (/^File integrity check failed, upload terminated\.$/.test(error[1])){
									image[STATUS] = ERROR_INTEG;
									}else{
										image[STATUS] = ERROR_MISC;
									}
									}else{
										image[STATUS] = ERROR_MISC;
									}
								}
								requestDone(image);
							},
							login:
							function()
							{
								logout();
								this.doLogin(false, null);
							},
							doLogin:
							function(force_login, username)
							{
								openDialog("host" + IMAGESHACK + "_login.xul", "", "chrome, dialog, modal, centerscreen", force_login, username, this);
							},
							logout:
							function()
							{
								this.username = null;
								removeCookies(".imageshack.us");
							},
							del_callbacks:
							{
								onChannelRedirect:
								function(oldChannel, newChannel, flags)
								{
									throw Components.results.NS_ERROR_FAILURE;
								},
								getInterface:
								function(uuid)
								{
									if (uuid.equals(Components.interfaces.nsIChannelEventSink))
									{
										return this;
									}
									return null;
								}
							},
							deleteImage:
							function(image)
							{
								if (this.isLoggedIn())
								{
									if (this.username == image[USER])
									{
										return this.deleteImage2(image);
										}else{
											logout();
											this.doLogin(true, image[USER]);
											if (this.isLoggedIn())
											{
												updateLoginDisplay();
												return this.deleteImage2(image);
												}else{
													return false;
												}
											}
											}else{
												this.doLogin(true, image[USER]);
												if (this.isLoggedIn())
												{
													updateLoginDisplay();
													return this.deleteImage2(image);
													}else{
														return false;
													}
												}
											},
											deleteImage2:
											function(image)
											{
												var XMLHttpRequest_request = new XMLHttpRequest();
												XMLHttpRequest_request.open("GET", "http://my.imageshack.us/dbclient.php?action=delete&id=" + encodeURIComponent(image[URL].match(/http:\/\/[^]*?\/([^]*)/)[1]), true);
												XMLHttpRequest_request.channel.notificationCallbacks = this.del_callbacks;
												XMLHttpRequest_request.send(null);
												return true;
											}
										};

										hosts[PHOTOBUCKET] =
										{
											name: "Photobucket",
											types: ["jpeg", "JPEG", "jpg", "JPG", "png", "PNG", "gif", "GIF", "bmp", "BMP", "tif", "TIF", "tiff", "TIFF", "swf", "SWF"],
											min_size: 0,
											max_size: 1073741824,
											login_required: true,
											prefs: ["auto_login", "use_album", "album", "use_description", "preserve_names"],
											username: null,
											domain: null,
											dir: null,
											init:
											function()
											{
												if (this.auto_login)
												{
													this.doLogin(true, null);
												}
											},
											isLoggedIn:
											function()
											{
												return (this.username && this.domain && this.dir) ? true : false;
											},
											getUploadUrl:
											function()
											{
												return "http://" + this.domain + ".photobucket.com/albums/" + this.dir + "/" + this.username + "/" + (this.use_album ? this.album + "/" : "");
											},
											getUserName:
											function()
											{
												return this.username;
											},
											getStreamData:
											function(file_name)
											{
												return "\r\n-----------------------------" + multipart_boundary + "\r\nContent-Disposition: form-data; name=\"action\"\r\n\r\nuploadimage\r\n-----------------------------" + multipart_boundary + (this.preserve_names ? "\r\nContent-Disposition: form-data; name=\"preserve\"\r\n\r\ntrue\r\n-----------------------------" + multipart_boundary : "") + (this.use_description ? "\r\nContent-Disposition: form-data; name=\"image_desc\"\r\n\r\n" + prompt("Enter description for " + file_name) + "\r\n-----------------------------" + multipart_boundary : "") + "\r\nContent-Disposition: form-data; name=\"the_image\"; filename=\"" + file_name + "\"\r\nContent-Type: image\r\n\r\n";
											},
											processUpload:
											function(responseText, image)
											{
												var msg = responseText.match(/<div id="errormsg">(.*?)<\/div>/);
												if (msg)
												{
													switch (msg)
													{
														default:
														image[STATUS] = ERROR_MISC;
													}
													requestDone(image);
													}else{
														var req = new XMLHttpRequest();
														req.open("POST", this.getUploadUrl(), true);
														this.handleEvent = this.processUpload2;
														this.image = image;
														req.onload = this;
														req.send("action=completeupload&filename[]=" + encodeURIComponent(responseText.match(/id="filename">(.*?)<\/div>/)[1]));
													}
												},
												processUpload2:
												function(event)
												{
													var image = this.image;
													image[STATUS] = DONE;
													var image_url = event.target.responseText.match(/id="mediaUrl_0" value="(.*?)">/)[1];
													image[URL] = image_url;
													image[THUMB] = image_url.replace(/^([^]*\/)([^]*?)$/, "$1th_$2");
													requestDone(image);
												},
												login:
												function()
												{
													logout();
													this.doLogin(false, null);
												},
												doLogin:
												function(force_login, username)
												{
													openDialog("host" + PHOTOBUCKET + "_login.xul", "", "chrome, dialog, modal, centerscreen", force_login, username, this);
												},
												logout:
												function()
												{
													this.username = null;
													this.dir = null;
													this.domain = null;
													removeCookies(".photobucket.com");
												},
												deleteImage:
												function(image)
												{
													if (this.isLoggedIn())
													{
														if (this.username == image[USER])
														{
															return this.deleteImage2(image);
															}else{
																logout();
																this.doLogin(true, image[USER]);
																if (this.isLoggedIn())
																{
																	updateLoginDisplay();
																	return this.deleteImage2(image);
																	}else{
																		return false;
																	}
																}
																}else{
																	this.doLogin(true, image[USER]);
																	if (this.isLoggedIn())
																	{
																		updateLoginDisplay();
																		return this.deleteImage2(image);
																		}else{
																			return false;
																		}
																	}
																},
																deleteImage2:
																function(image)
																{
																	var pic = image[URL].match(/^[^]*\/([^]*?)$/)[1];
																	XMLHttpRequest_request = new XMLHttpRequest();
																	XMLHttpRequest_request.open("POST", image[URL].replace(/^(http:\/\/)[^]*?(\.[^]*\/)[^]*?$/, "$1" + this.domain + "$2"), true);
																	XMLHttpRequest_request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
																	XMLHttpRequest_request.send("action=delete&selectedmedia%5B%5D=" + encodeURIComponent(pic));
																	return true;
																}
															};
