var
nsIPrefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("imgbot.template_editor."),
////////////////
template_array = eval(nsIPrefBranch.getCharPref("template_array")),
////////////////
locale_elt = document.getElementById("locale"),
////////////////
move_up_elt = document.getElementById("move_up"),
move_down_elt = document.getElementById("move_down"),
name_elt = document.getElementById("name"),
start_elt = document.getElementById("start"),
end_elt = document.getElementById("end"),
contents_elt = document.getElementById("contents"),
separator_elt = document.getElementById("separator"),
text_preview_elt = document.getElementById("text_preview"),
html_preview_elt = document.getElementById("html_preview"),
save_elt = document.getElementById("save"),
delete_elt = document.getElementById("delete"),
template_tree_context_elt = document.getElementById("template_tree_context"),
template_treechildren_elt = document.getElementById("template_treechildren"),
template_tree_elt = document.getElementById("template_tree"),
////////////////
move_buttons_box_elt = document.getElementById("move_buttons"),
action_buttons_box_elt = document.getElementById("action_buttons"),
name_box_elt = document.getElementById("name_box"),
start_box_elt = document.getElementById("start_box"),
end_box_elt = document.getElementById("end_box"),
contents_box_elt = document.getElementById("contents_box"),
separator_box_elt = document.getElementById("separator_box"),
text_preview_box_elt = document.getElementById("text_preview_box"),
html_preview_box_elt = document.getElementById("html_preview_box"),
status_bar_elt = document.getElementById("status_bar"),
status_text_elt = document.getElementById("status_text"),
////////////////
preview_array = eval("[[\"http://www.mozilla.org/foundation/identity-guidelines/firefox-128.png\", 518, \"firefox-128.png\", 1, 32382, \"http://www.mozilla.org/foundation/identity-guidelines/firefox-wordmark-bad-examples.png\", 0, \"e**2cc95c****e88a17***62728**3e0\"],[\"http://www.mozilla.org/foundation/identity-guidelines/firefox-128.png\", 518, \"firefox-128.png\", 1, 32382, \"http://www.mozilla.org/foundation/identity-guidelines/firefox-wordmark-bad-examples.png\", 0, \"e**2cc95c****e88a17***62728**3e0\"],[\"http://www.mozilla.org/foundation/identity-guidelines/firefox-128.png\", 518, \"firefox-128.png\", 1, 32382, \"http://www.mozilla.org/foundation/identity-guidelines/firefox-wordmark-bad-examples.png\", 0, \"e**2cc95c****e88a17***62728**3e0\"]]"),
////////////////
nsITreeView_tree =
{
	rowCount: template_array.length,
	getCellText:
	function(row)
	{
		return template_array[row][TEMPLATE_NAME];
	},
	setTree:
	function(treebox){
		if (treebox)
		{
			this.treebox = treebox;
		}
	},
	cycleHeader: function(){},
	isContainer: function(){ return false; },
	isSeparator: function(){ return false; },
	isSorted: function(){ return false; },
	getLevel: function(){ return 0; },
	getImageSrc: function(){ return null; },
	getRowProperties: function(){},
	getCellProperties: function(){},
	getColumnProperties: function(){}
};

updateStatus("initialized", [navigator.userAgent.split(" ").pop()]);
template_tree_elt.view = nsITreeView_tree;
template_tree_elt.onselect = checkSelection;
updateSettings();
disableAndClearInputs();

function checkSelection()
{
	if (nsITreeView_tree.selection.count)
	{
		updateStatus("selected", [template_array[nsITreeView_tree.selection.currentIndex][TEMPLATE_NAME]]);
		save_elt.setAttribute("disabled", false);
		delete_elt.setAttribute("disabled", false);
		name_elt.disabled = false;
		start_elt.disabled = false;
		end_elt.disabled = false;
		contents_elt.disabled = false;
		separator_elt.disabled = false;
		text_preview_elt.disabled = false;
		updateInputs();
		updatePreview();
	}else{
		disableAndClearInputs();
	}
}

function disableAndClearInputs()
{
	save_elt.setAttribute("disabled", true);
	delete_elt.setAttribute("disabled", true);
	name_elt.disabled = true;
	start_elt.disabled = true;
	end_elt.disabled = false;
	contents_elt.disabled = true;
	separator_elt.disabled = true;
	text_preview_elt.disabled = true;
	name_elt.value = null;
	contents_elt.value = null;
	separator_elt.value = null;
	text_preview_elt.value = null;
	html_preview_elt.setAttribute("src", "about:blank");
}

function moveUp()
{
	var upperIndex = nsITreeView_tree.selection.currentIndex;
	var lowerIndex = upperIndex - 1;
	var lower = template_array[lowerIndex];
	var upper = template_array[upperIndex];
	template_array[lowerIndex] = upper;
	template_array[upperIndex] = lower;
	nsITreeView_tree.treebox.invalidateRow(upperIndex);
	nsITreeView_tree.treebox.invalidateRow(lowerIndex);
	nsITreeView_tree.selection.select(lowerIndex);
	updateStatus("movedUp", []);
}

function moveDown()
{
	var lowerIndex = nsITreeView_tree.selection.currentIndex;
	var upperIndex = lowerIndex + 1;
	var upper = template_array[upperIndex];
	var lower = template_array[lowerIndex];
	template_array[upperIndex] = lower;
	template_array[lowerIndex] = upper;
	nsITreeView_tree.treebox.invalidateRow(lowerIndex);
	nsITreeView_tree.treebox.invalidateRow(upperIndex);
	nsITreeView_tree.selection.select(upperIndex);
	updateStatus("movedDown", []);
}

function createTemplate()
{
	var insertIndex = nsITreeView_tree.selection.currentIndex;
	if (insertIndex == -1)
	{
		insertIndex = template_array.length - 1;
	}
	nsITreeView_tree.treebox.rowCountChanged(template_array.length, 1);
	template_array.splice(insertIndex, 0, ["New Template", "", "", "", ""]);
	nsITreeView_tree.treebox.invalidate();
	nsITreeView_tree.selection.select(insertIndex);
	checkSelection();
	updateStatus("created", []);
}

function saveTemplate()
{
	var currentIndex = nsITreeView_tree.selection.currentIndex;
	var row = template_array[currentIndex];
	row[TEMPLATE_NAME] = name_elt.value;
	row[TEMPLATE_START] = start_elt.value;
	row[TEMPLATE_END] = end_elt.value;
	row[TEMPLATE_CONTENTS] = contents_elt.value;
	row[TEMPLATE_SEPARATOR] = separator_elt.value;
	nsITreeView_tree.treebox.invalidateRow(currentIndex);
	updateStatus("saved", []);
}

function deleteSelection()
{
	var currentIndex = nsITreeView_tree.selection.currentIndex;
	if ((template_array.length == 1) || (currentIndex == template_array.length - 1))
	{
		disableAndClearInputs();
	}
	nsITreeView_tree.treebox.rowCountChanged(currentIndex, -1);
	updateStatus("deleted", [template_array.splice(currentIndex, 1)[0][TEMPLATE_NAME]]);
}

function updateStatus(key, replace_array)
{
	status_text_elt.value = locale_elt.getFormattedString("template_editor." + key, replace_array);
}

function updateInputs()
{
	var currentIndex;
	if (template_array.length == 1)
	{
		currentIndex = 0;
		move_down_elt.setAttribute("disabled", true);
	}else{
		currentIndex = nsITreeView_tree.selection.currentIndex;
	}
	if (currentIndex == 0)
	{
		move_up_elt.setAttribute("disabled", true);
	}else if (currentIndex == template_array.length - 1){
		move_down_elt.setAttribute("disabled", true);
	}else{
		move_up_elt.setAttribute("disabled", false);
		move_down_elt.setAttribute("disabled", false);
	}
	var row = template_array[currentIndex];
	name_elt.value = row[TEMPLATE_NAME];
	start_elt.value = row[TEMPLATE_START];
	end_elt.value = row[TEMPLATE_END];
	contents_elt.value = row[TEMPLATE_CONTENTS];
	separator_elt.value = row[TEMPLATE_SEPARATOR];
}

function updatePreview()
{
	try
	{
		var copy_array = [], func = eval("(function(){return " + contents_elt.value + "})");
		for (var a = 0; a < 3; a++)
		{
			var image = preview_array[a];
			copy_array[a] = func();
		}
	}
	catch(e)
	{
		text_preview_elt.value = null;
		html_preview_elt.setAttribute("src", "about:blank");
		save_elt.setAttribute("disabled", true);
		return;
	}
	var data = start_elt.value + copy_array.join(separator_elt.value) + end_elt.value;
	text_preview_elt.value = data;
	html_preview_elt.setAttribute("src", "data:text/html," + escape(data));
	save_elt.setAttribute("disabled", false);
}

function updateSettings()
{
	move_buttons_box_elt.setAttribute("collapsed", nsIPrefBranch.getBoolPref("hide_move_buttons"));
	action_buttons_box_elt.setAttribute("collapsed", nsIPrefBranch.getBoolPref("hide_action_buttons"));
	if (nsIPrefBranch.getBoolPref("hide_context"))
	{
		template_tree_context_elt.hidePopup();
		template_treechildren_elt.contextMenu = null;
	}else{
		template_treechildren_elt.contextMenu = "template_tree_context";
	}
	name_box_elt.setAttribute("collapsed", nsIPrefBranch.getBoolPref("hide_name"));
	start_box_elt.setAttribute("collapsed", nsIPrefBranch.getBoolPref("hide_start"));
	end_box_elt.setAttribute("collapsed", nsIPrefBranch.getBoolPref("hide_end"));
	contents_box_elt.setAttribute("collapsed", nsIPrefBranch.getBoolPref("hide_contents"));
	separator_box_elt.setAttribute("collapsed", nsIPrefBranch.getBoolPref("hide_separator"));
	text_preview_box_elt.setAttribute("collapsed", nsIPrefBranch.getBoolPref("hide_text_preview"));
	html_preview_box_elt.setAttribute("collapsed", nsIPrefBranch.getBoolPref("hide_html_preview"));
	status_bar_elt.setAttribute("collapsed", nsIPrefBranch.getBoolPref("hide_status_bar"));
}

function onunload()
{
	nsIPrefBranch.setCharPref("template_array", template_array.toSource());
}